# 介绍

> 开箱即用的28181协议视频平台

# 概述
- WVP-PRO基于GB/T 28181-2016标准实现的流媒体平台，依托优秀的开源流媒体服务[ZLMediaKit](https://github.com/ZLMediaKit/ZLMediaKit)，提供完善丰富的功能。
- GB/T 28181-2016 中文标准名称是《公共安全视频监控联网系统信息传输、交换、控制技术要求》是监控领域的国家标准。大量应用于政府视频平台。
- 通过28181协议你可以将IPC摄像头接入平台，可以观看也可以使用28181/rtsp/rtmp/flv等协议将视频流分发到其他平台。

# 特性
- 实现标准的28181信令，兼容常见的品牌设备，比如海康、大华、宇视等品牌的IPC、NVR以及平台。
- 支持将国标设备级联到其他国标平台，也支持将不支持国标的设备的图像或者直播推送到其他国标平台
- 前端完善，自带完整前端页面，无需二次开发可直接部署使用。
- 完全开源，且使用MIT许可协议。保留版权的情况下可以用于商业项目。
- 支持多流媒体节点负载均衡。

# 我们实现了哪些国标功能
**作为上级平台**
- [X] 注册
- [X] 注销
- [X] 实时视音频点播
- [X] 设备控制
  - [X] 云台控制
  - [ ] 远程启动
  - [ ] 录像控制
  - [ ] 报警布防/撤防
  - [ ] 报警复位
  - [X] 强制关键帧
  - [ ] 拉框放大
  - [ ] 拉框缩小
  - [ ] 看守位控制
  - [ ] 设备配置
- [X] 报警事件通知和分发
- [X] 设备目录订阅
- [X] 网络设备信息查询
  - [X] 设备目录查询
  - [X] 设备状态查询
  - [ ] 设备配置查询
  - [ ] 设备预置位查询
- [X] 状态信息报送
- [X] 设备视音频文件检索
- [X] 历史视音频的回放
  - [X] 播放
  - [X] 暂停
  - [X] 进/退
  - [X] 停止
- [X] 视音频文件下载
- [X] 校时
- [X] 订阅和通知
  - [X] 事件订阅
    - [X] 移动设备位置订阅
    - [X] 报警订阅
    - [X] 目录订阅
- [ ] 语音广播
- [ ] 语音对讲

**作为下级平台**
- [X] 注册
- [X] 注销
- [X] 实时视音频点播
- [ ] 设备控制
  - [ ] 云台控制
  - [ ] 远程启动
  - [ ] 录像控制
  - [ ] 报警布防/撤防
  - [ ] 报警复位
  - [ ] 强制关键帧
  - [ ] 拉框放大
  - [ ] 拉框缩小
  - [ ] 看守位控制
  - [ ] 设备配置
- [ ] 报警事件通知和分发
- [X] 设备目录订阅
- [X] 网络设备信息查询
  - [X] 设备目录查询
  - [X] 设备状态查询
  - [ ] 设备配置查询
  - [ ] 设备预置位查询
- [X] 状态信息报送
- [X] 设备视音频文件检索
- [X] 历史视音频的回放
  - [X] 播放
  - [x] 暂停
  - [x] 进/退
  - [x] 停止
- [ ] 视音频文件下载
- [ ] ~~校时~~
- [X] 订阅和通知
  - [X] 事件订阅
    - [X] 移动设备位置订阅
    - [ ] 报警订阅
    - [X] 目录订阅
- [ ] 语音广播
- [ ] 语音对讲

   


# 社区
代码目前托管在GitHub和Gitee，Gitee目前作为加速仓库使用，不接受issue。  
GitHub： [https://github.com/648540858/wvp-GB28181-pro](https://github.com/648540858/wvp-GB28181-pro)  
Gitee： [https://gitee.com/pan648540858/wvp-GB28181-pro](https://gitee.com/pan648540858/wvp-GB28181-pro)